# mypy-boto3-sms

[![PyPI - mypy-boto3-sms](https://img.shields.io/pypi/v/mypy-boto3-sms.svg?color=blue)](https://pypi.org/project/mypy-boto3-sms)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-sms.svg?color=blue)](https://pypi.org/project/mypy-boto3-sms)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-sms](#mypy-boto3-sms)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)

Type annotations for
[boto3.SMS 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/sms.html#SMS) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `SMS` service.

```bash
python -m pip install boto3-stubs[sms]
```

Use `boto3` with `mypy_boto3_sms` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_sms import SMSClient

# Now mypy can check if your code is valid.
client: SMSClient = boto3.client("sms")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: SMSClient = session.client("sms")



# Annotated paginators are included as well

import mypy_boto3_sms.paginator as sms_paginators

get_connectors_paginator: sms_paginators.GetConnectorsPaginator = client.get_paginator("get_connectors")
get_replication_jobs_paginator: sms_paginators.GetReplicationJobsPaginator = client.get_paginator("get_replication_jobs")
get_replication_runs_paginator: sms_paginators.GetReplicationRunsPaginator = client.get_paginator("get_replication_runs")
get_servers_paginator: sms_paginators.GetServersPaginator = client.get_paginator("get_servers")
list_apps_paginator: sms_paginators.ListAppsPaginator = client.get_paginator("list_apps")
```

## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_sms` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python
import boto3

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("sms")

session_client = boto3.Session().client("sms")
```